#
#	This file is part of stov, written by Helmut Pozimski in 2012.
#
#	stov is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, version 2 of the License.
#
#	stov is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with stov.  If not, see <http://www.gnu.org/licenses/>.


# -*- coding: utf8 -*-

import os
import sys
import gettext
import sqlite3
import subprocess


class video(object):
	def __init__(self, title, description, ytid, conf, downloaded, id=0):
		self.__ID = id
		self.title = title
		self.description = description
		self.ytid = ytid
		self.__conf = conf
		self.__downloaded = downloaded

	def DownloadVideo(self, directory):
		"""Downloads the video by calling youtube-dl as an external process"""
		self.__targetdir = self.__conf.values["downloaddir"] + "/" + directory
		if os.access(self.__targetdir, os.F_OK) is False:
			try:
				os.makedirs(self.__targetdir, 0750)
			except os.error:
				print >> sys.stderr, _("Download directory does not exist \
and can't be created. Please check your configuration and try again")

		os.chdir(self.__targetdir)
		if self.__downloaded == 0:
			try:
				subprocess.check_call(["youtube-dl", "--max-quality=22", "-t",
				"http://www.youtube.com/watch?v=%s" % self.ytid],
				stderr=sys.stderr, stdout=open("/dev/null", "w"))
				try:
					self.__database = sqlite3.connect(self.__conf.dbpath)
				except sqlite3.OperationalError:
					print >> sys.stderr, _("The Video \"%s\" has been "
								"downloaded but the status could not be updated in the database. "
								"Please check what went wrong and correct it" % self.title)
				else:
					self.__cursor = self.__database.cursor()
					self.__query = "UPDATE videos SET downloaded ='1' WHERE id = ?"
					self.__cursor.execute(self.__query, (self.__ID,))
					self.__database.commit()
					self.__database.close()

			except subprocess.CalledProcessError:
				print >> sys.stderr, _("The video %s could not be downloaded "
							"due to some problem with youtube-dl. If this happens to more than one "
							"video, please check your youtube-dl version")
				return False
			else:
				return True

	def AssignDBID(self, id):
		self.__ID = id
